#ifndef _EDITOR_RESIZER_BAR_
#define _EDITOR_RESIZER_BAR_

#include "imtrjuce.h"

class EditorResizerBar;

class  EditorResizerListener
{
public:
  virtual ~EditorResizerListener() {};
  virtual int getBarCurrentPosition(EditorResizerBar *bar) = 0;
  virtual void setBarPosition(EditorResizerBar *bar, int position) = 0;
  virtual void endResizing(EditorResizerBar *bar) = 0;
};

class EditorResizerBar  : public JUCE_EDITOR_NAMESPACE::Component
{
public:
  EditorResizerBar (EditorResizerListener *listener, JUCE_EDITOR_NAMESPACE::Component *prev, JUCE_EDITOR_NAMESPACE::Component *next, bool isBarVertical);
  
  ~EditorResizerBar();

  void paint (JUCE_EDITOR_NAMESPACE::Graphics& g);
  void mouseDown (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
  void mouseDrag (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
  void mouseUp (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
  
  JUCE_EDITOR_NAMESPACE::Component *getPreviousComponent(){return prev;}
  JUCE_EDITOR_NAMESPACE::Component *getNextComponent(){ return next;}
    
  void setColor(bool isBackground, JUCE_EDITOR_NAMESPACE::Colour color);
  void setOrientation(bool isVertical);
private:
    EditorResizerListener* listener;
    JUCE_EDITOR_NAMESPACE::Component *prev;
    JUCE_EDITOR_NAMESPACE::Component *next;
    int mouseDownPos;
    bool isVertical;
    
    bool colorAsEditorBackground;
    JUCE_EDITOR_NAMESPACE::Colour bgcolor;
};

#endif  // _EDITOR_RESIZER_BAR_
