
#ifndef _EDITOR_SCROLLBAR_H_
#define _EDITOR_SCROLLBAR_H_

/*#include "../../../events/juce_AsyncUpdater.h"
#include "../../../events/juce_Timer.h"*/
//#include "src/juce_WithoutMacros.h"
#include "juce.h"
#include "ScrollZoomListener.h"

class EditorScrollBar: public JUCE_EDITOR_NAMESPACE::Component
{
public:
    EditorScrollBar(EditorContainer *container, const bool isVertical);

    ~EditorScrollBar();

    //==============================================================================
    void clearListeners();
    void addListener(ScrollZoomListener * const listener);
    void removeListener(ScrollZoomListener * const listener);
    void updateToListeners();
    
    //==============================================================================
    bool isVertical() const                             { return vertical; }
    bool isEnabled() const                             { return enabled; }
    void setOrientation (const bool shouldBeVertical);
    
    //==============================================================================    
    JUCE_EDITOR_NAMESPACE::Colour getScrollbarColor();
    void setScrollbarColor(bool isBackground, JUCE_EDITOR_NAMESPACE::Colour color);
    bool isColorChanged() {return colorChanged;}
  
    //==============================================================================
    void setRangeLimits (const double minimum, const double maximum);

    double getMinimumRangeLimit() const                 { return minimum; }
    double getMaximumRangeLimit() const                 { return maximum; }

    //==============================================================================
    void setCurrentRange (double newStart, double newSize);
    void setCurrentRangeStart (double newStart);
    double getCurrentRangeStart() const                 { return rangeStart; }
    double getCurrentRangeSize() const                  { return rangeSize; }
        
    //==============================================================================
    void setSingleStepSize (const double newSingleStepSize);
    void moveScrollbarInSteps (const int howManySteps);
    void moveScrollbarInPages (const int howManyPages);
    //==============================================================================
    void mouseDown (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
    void mouseDrag (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
    void mouseDoubleClick (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
    void mouseUp   (const JUCE_EDITOR_NAMESPACE::MouseEvent& e);
    void paint (JUCE_EDITOR_NAMESPACE::Graphics& g);
    void resized();
    void update();
    
    EditorContainer *container;
private:
    //==============================================================================
    double minimum, maximum;
    double rangeStart, rangeSize;
    double singleStepSize, dragStartRange;
    int thumbAreaStart, thumbAreaSize, thumbStart, thumbSize;
    int dragStartMousePos, lastMousePos;
    bool vertical, isDraggingThumb, enabled;
    
    JUCE_EDITOR_NAMESPACE::Array <ScrollZoomListener *> listeners;
    
    bool zooming;
    int prev_dpix;
    
    JUCE_EDITOR_NAMESPACE::Colour scrollColor;
    bool scrollColorAsEditorBackground;
    bool colorChanged;
    
    void updateThumbPosition();
    int getMinimumThumbSize();
    void updateCurrentRange(); 
};

#endif   // _EDITOR_SCROLLBAR_H_
